Work in progress version of code to (1) reconstruct historic harvest of Atnarko Sockeye in directed, mixed stock and incidental fisheries on the Central Coast of BC (2) fit an age-structured state-space stock-recruit model to available data to inform simulations that quantify the impact of plausible future harvest rates on prospects for recovery and (3) develop a simple generalized migration, harvest and catch monitoring simulation to evaluate how well alternative catch sampling strategies reduce uncertainty in estimates of catch composition.

Stock-recruit model is modified from: Fleischman, S.J., Catalano, M.J., Clark, R.A. and Bernard, D.R., 2013. An age-structured state-space stock-recruit model for Pacific salmon (Oncorhynchus spp.). Canadian Journal of Fisheries and Aquatic Sciences, 70(3): 401-414.  

Catch monitoring simulation code from W. Atlas (SFU)

## Files
- `make.R`: All code required to reproduce current set of simulations and figures. Individual figures (named  `Figure_...`) are sourced from this code.

- `load.R`: Loads packages and scripts necessary for analysis. This file should be sourced prior to running other scripts.

- `functions.R`: All functions written for the analysis should be placed in this file.
  

