Code to (1) reconstruct historic harvest of Atnarko Sockeye in directed, mixed stock and incidental fisheries on the Central Coast of BC (2) fit an age-structured state-space stock-recruit model to available data to partameterize simulations that quantify the impact of potential future harvest rates on prospects for recovery and (3) run a simple generalized migration, harvest and catch monitoring simulation to evaluate how well alternative catch sampling strategies reduce uncertainty in estimates of catch composition:

>Connors, B.M., W.I. Atlas, C. Melymick, M. Moody, and J. Moody. 2019. Conservation Risk and Uncertainty in Recovery Prospects for a Collapsed and Culturally Important Salmon Population in a Mixed-Stock Fishery. Marine and Coastal Fisheries: Dynamics, Management, and Ecosystem Science.

Spawner-recruitment model modified from:
>Fleischman, S.J., Catalano, M.J., Clark, R.A. and Bernard, D.R., 2013. An age-structured state-space stock-recruit model for Pacific salmon (Oncorhynchus spp.). Canadian Journal of Fisheries and Aquatic Sciences, 70(3): 401-414.

Catch monitoring simulation code by W. Atlas (SFU).


## Files
- `make.R`: All code required to reproduce analyses, simulations and figures. Individual figures (named  `Figure_...`) are sourced from this code.

- `load.R`: Loads packages and scripts necessary for analysis. This file should be sourced prior to running other scripts.

- `functions.R`: All functions written for the analysis are placed in this file.
  

